
import java.awt.Dimension;

import javax.swing.*;

import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;

/** 
 ** Tests that the layout algorithm determines initial, tightest fitting
 ** to preferred-size-based, row sizes correctly when no extra space is
 ** added to the rows.
 ** 
 **/ 
@SuppressWarnings("serial")
public class Test01RowLayout extends JComponentBreadboard {
   public Test01RowLayout() {
	  final int SIZE = 100;
      JComponent[][] button = new JButton[2][4];
      for (int i = 0; i < 2; i++) {
         for (int j = 0; j < 4; j++) {
            button[i][j] = new JButton(i+ "," + j);
            button[i][j].setPreferredSize(new 
            		Dimension(SIZE, i==0?(j+1)*SIZE:(4-j)*SIZE));
         }
      }
      JLabel msg = new JLabel(
"Verify: Left to right, top buttons grow, bottom shrink, to form interlocking square.");
      Object[][] breadboard = {
         {button[0][0], button[0][1], button[0][2], button[0][3]},  
         {button[1][0], button[0][1], button[0][2], button[0][3]},  
         {button[1][0], button[1][1], button[0][2], button[0][3]},  
         {button[1][0], button[1][1], button[1][2], button[0][3]},  
         {button[1][0], button[1][1], button[1][2], button[1][3]},
         {msg,          msg,          msg,          msg}
      };
      setBreadboard(breadboard);
   }
}
