
import java.awt.Dimension;

import javax.swing.*;

import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;

/** 
 ** Tests that the layout algorithm determines initial, tightest fitting
 ** to preferred-size-based, column sizes correctly when no extra space is
 ** added to the columns.
 ** 
 **/ 
@SuppressWarnings("serial")
public class Test02ColLayout extends JComponentBreadboard {
   public Test02ColLayout() {
	  final int SIZE = 100;
      JComponent[][] button = new JButton[4][2];
      for (int i = 0; i < 4; i++) {
         for (int j = 0; j < 2; j++) {
            button[i][j] = new JButton(i+ "," + j);
            button[i][j].setPreferredSize(new 
            		Dimension(j==0?(i+1)*SIZE:(4-i)*SIZE, SIZE));
         }
      }
      JLabel msg = new JLabel(
"Verify: top to bottom, left buttons grow, right shrink, to form interlocking square.");
      Object[][] breadboard = {
         {button[0][0], button[0][1], button[0][1], button[0][1], button[0][1]},  
         {button[1][0], button[1][0], button[1][1], button[1][1], button[1][1]},  
         {button[2][0], button[2][0], button[2][0], button[2][1], button[2][1]},  
         {button[3][0], button[3][0], button[3][0], button[3][0], button[3][1]},  
         {msg,          msg,          msg,          msg,          msg}
      };
      setBreadboard(breadboard);
   }
}
