
import javax.swing.*;

import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;

/** 
 ** Tests the xFill, yFill, xyFill, and xyFillNone layout directive functions,
 ** 
 **/ 
@SuppressWarnings("serial")
public class Test03FillTest extends JComponentBreadboard {
   public Test03FillTest() {
	 JComponent[][] buttons = new JButton[3][3];
       for (int i=0; i < buttons.length; i++)
	      for (int j=0; j < buttons[i].length; j++)
	      	buttons[i][j] = new JButton();
// just check that the array forms propagate to each element	 
      xFill(buttons);
      for (int i=0; i < buttons.length; i++)
         for (int j=0; j < buttons[i].length; j++)
            if (isYFilled(buttons[i][j]) ||
               !isXFilled(buttons[i][j]))
               throw new AssertionError("xFill 2D array test failed.");
      xFill(false, yFill(buttons));
      for (int i=0; i < buttons.length; i++)
         for (int j=0; j < buttons[i].length; j++)
            if (!isYFilled(buttons[i][j]) ||
                isXFilled(buttons[i][j]))
               throw new AssertionError("yFill 2D array test failed.");
      xyFill(buttons);
      for (int i=0; i < buttons.length; i++)
         for (int j=0; j < buttons[i].length; j++)
            if (!isYFilled(buttons[i][j]) ||
               !isXFilled(buttons[i][j]))
               throw new AssertionError("xyFill 2D array test failed.");
      xyFill(false, false, buttons);
      for (int i=0; i < buttons.length; i++)
         for (int j=0; j < buttons[i].length; j++)
            if (isYFilled(buttons[i][j]) ||
               isXFilled(buttons[i][j]))
               throw new AssertionError("xyFill(false, false, 2D array) test failed.");


      xyFill(buttons[0]);
      for (int i=0; i == 0; i++)
         for (int j=0; j < buttons[i].length; j++)
            if (!isYFilled(buttons[i][j]) ||
               !isXFilled(buttons[i][j]))
               throw new AssertionError("xyFill 1D array test failed.");
	   
      JComponent xyFillNone = xyAlign(0,0,xyFill(false, false, new JButton("xyFillNone")));
      JComponent xyFill = xyAlign(0,0,xyFill(new JButton("xyFill")));
      JComponent xFill = xyAlign(0,0,xFill(new JButton("xFill")));
      JComponent yFill = xyAlign(0,0,yFill(new JButton("yFill")));

      JComponent vScrollBar = new JScrollBar(SwingConstants.VERTICAL);
      JComponent hScrollBar = new JScrollBar(SwingConstants.HORIZONTAL);
// this line tests that fill attributes get overridden as expected:
      yFill = yFill(xyFill(false, false, xFill(yFill)));
     final int SIZE = 200;
      JLabel msg = new JLabel(
"<html>Verify: UpperLeft not filled; LowerLeft vert. filled; <br>UpperRight horiz. filled; LowerRight both filled.<br>scrollbars filled as expected.");
      Object[][] breadboard = {
         {null,         xSpace(SIZE),ySep(),  xSpace(SIZE),  ySep(), vScrollBar},
         {ySpace(SIZE), xyFillNone,  ySep(),  xFill,         "",     ""},
         {xSep(),       xSep(),      xSep(),  xSep(),        "",     ""},
         {ySpace(SIZE), yFill,       ySep(),  xyFill,        "",     ""},
         {xSep(),       xSep(),      xSep(),  xSep(),        "",     ""},
         {hScrollBar,   __,          __,      __,            __,     ""},
         {msg,          msg,         msg,     msg,           msg,    msg}           
      };
      setBreadboard(breadboard);
   }
   public static void main(String[] args) {
	   showMessageBreadboard(null, new Test03FillTest(),"Test03FillTest()");
   }
}
      
      