
import javax.swing.*;

import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;

/** 
 ** Tests that rows and columns scale as expected with various scaling options
 ** 
 **/ 
@SuppressWarnings("serial")
public class Test04ScaleOption extends JComponentBreadboard {
   public Test04ScaleOption(boolean useHeaders) {
	 JComponent[][] buttons = new JButton[4][4];
     JLabel[][] colNames = {{(JLabel) xAlign(0.5,new JLabel("NOSCALE")),
       (JLabel) xAlign(0.5,new JLabel(useHeaders ? "SHRINKS":"NOSCALE")),
       (JLabel) xAlign(0.5,new JLabel(useHeaders ? "EXPANDS" : "NOSCALE")),
       (JLabel) xAlign(0.5,new JLabel(useHeaders ? "BISCALE":"NOSCALE"))}};

     JLabel[][] rowNames = {{new JLabel("NOSCALE")},
                            {new JLabel(useHeaders ? "SHRINKS" : "NOSCALE")},
                            {new JLabel(useHeaders ? "EXPANDS": "NOSCALE")},
                            {new JLabel(useHeaders ? "BISCALE": "NOSCALE")}};
     

     for (int i = 0; i < 4; i++) {
         for (int j = 0; j < 4; j++) {
            buttons[i][j] = xyFill(new JButton(rowNames[i][0].getText()  + "," +
                                              colNames[0][j].getText()));
         }
      }
      JLabel msg = new JLabel(
 "<html>Verify: every row/column scales up/down as indicated when parent is resized. <br>NoScale stays in lower right corner.");
      JLabel hdrs = new JLabel(useHeaders ? "Hdrs" :"NoHdrs");
     
      if (useHeaders) {
          Object[][] breadboard = {
         {null,    NOSCALE,  NOSCALE,  SHRINKS,      EXPANDS,      BISCALE},   
         {NOSCALE, hdrs,     colNames, colNames,     colNames,     colNames},
         {NOSCALE, rowNames, buttons,  buttons,      buttons,      buttons},  
         {SHRINKS, rowNames, buttons,  buttons,      buttons,      buttons},  
         {EXPANDS, rowNames, buttons,  buttons,      buttons,      buttons},  
         {BISCALE, rowNames, buttons,  buttons,      buttons,      buttons},  
         {NOSCALE, msg,      msg,      msg,          msg,          msg}
        };
        setBreadboard(breadboard);
      }
      else {
        Object[][] breadboard = {
         {hdrs,     colNames, colNames,     colNames,     colNames},
         {rowNames, buttons,  buttons,      buttons,      buttons},  
         {rowNames, buttons,  buttons,      buttons,      buttons},  
         {rowNames, buttons,  buttons,      buttons,      buttons},  
         {rowNames, buttons,  buttons,      buttons,      buttons},  
         {msg,      msg,      msg,          msg,          msg}
        };
        JComponent sub = xyAlign(1,1,new JComponentBreadboard(breadboard));
        setBreadboard(new Object[][] {{BISCALE, __},
        		                      {"",      sub} });
      }
   }
   public static void main(String[] args) {
	   showMessageBreadboard(null, new Test04ScaleOption(false),"Test04ScaleOption(false)");
	   showMessageBreadboard(null, new Test04ScaleOption(true),"Test04ScaleOption(true)");
   }
 }
