
import javax.swing.*;

import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;

/** 
 ** Tests that rows and columns scale as expected with various scaling options
 ** 
 **/ 
@SuppressWarnings("serial")
public class Test05Align extends JComponentBreadboard {
   public Test05Align() {
	 JComponent[][] buttons = new JButton[3][3];
     for (int i=0; i < buttons.length; i++)
	    for (int j=0; j < buttons[i].length; j++)
	    	buttons[i][j] = new JButton();
// just check that the array forms propagate to each element	 
	xyAlign(.1, .2, buttons);
	for (int i=0; i < buttons.length; i++)
	   for (int j=0; j < buttons[i].length; j++)
		   if (buttons[i][j].getAlignmentX() != .1f ||
			   buttons[i][j].getAlignmentY() != .2f)
			   throw new AssertionError("xyAlign 2D array test failed.");
	xyAlign(.3, .4, buttons[0]);
	for (int i=0; i < buttons[0].length; i++)
      if (buttons[0][i].getAlignmentX() != .3f ||
		  buttons[0][i].getAlignmentY() != .4f)
				   throw new AssertionError("xyAlign 1D array test failed.");

	for (int i = 0; i < 3; i++) {
         for (int j = 0; j < 3; j++) {
            buttons[i][j] = new JButton(((0==i)?"Top":(2==i)?"Bottom":"YCenter") + " " +
                     ((0==j)?"Left":(2==j)?"Right":"XCenter"));
            buttons[i][j] = xyAlign(j/2.0, i/2.0, buttons[i][j]);
         }
    }
    final int SIZE = 200;
    JLabel msg = new JLabel(
"Verify: buttons in each corner, aligned and centered on each edge, and at center.");
    Object[][] breadboard = {
         {null,         xSpace(SIZE), xSpace(SIZE), xSpace(SIZE), ySep()},
         {ySpace(SIZE), buttons,      buttons,      buttons,      ySep()},
         {ySpace(SIZE), buttons,      buttons,      buttons,      ySep()},
         {ySpace(SIZE), buttons,      buttons,      buttons,      ySep()},
         {xSep(),       xSep(),       xSep(),       xSep(),       null},  
         {msg,          msg,          msg,          msg,          msg}
      };
      setBreadboard(breadboard);
   }
   public static void main(String[] args) {
	   showMessageBreadboard(null, new Test05Align(),"Test05Align()");
   }
 }
