
import java.awt.Dimension;

import javax.swing.*;

import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;

/** 
 ** Tests that component sizes increase as expected with xUpsize and yUpsize
 ** 
 **/ 
@SuppressWarnings("serial")
public class Test06Upsize extends JComponentBreadboard {
    public Test06Upsize() {
      JComponent[][] buttons = new JButton[3][3];
         for (int i=0; i < buttons.length; i++)
	   for (int j=0; j < buttons[i].length; j++)
         buttons[i][j] = new JButton();
      xyUpsize(10, 20, buttons);
      for (int i=0; i < buttons.length; i++)
	     for (int j=0; j < buttons[i].length; j++)
		    if (getXUpsize(buttons[i][j]) != 10 ||
			     getYUpsize(buttons[i][j]) != 20)
			   throw new AssertionError("xyUpsize 2D array test failed.");
      xyUpsize(30, 40, buttons[0]);
      for (int i=0; i == 0; i++)
	     for (int j=0; j < buttons[i].length; j++)
		    if (getXUpsize(buttons[i][j]) != 30 ||
			     getYUpsize(buttons[i][j]) != 40)
			   throw new AssertionError("xyUpsize 1D array test failed.");
     
      final int SIZE = 150;
	   double[] factor = {-0.5, 0, 1.0}; // half sized, full sized, double sized
      for (int i = 0; i < 3; i++) {
         for (int j = 0; j < 3; j++) {
            buttons[i][j] = new JButton("X"+ i + " Y" + j);
            int width = SIZE;
            int height = SIZE;
            buttons[i][j].setPreferredSize(new Dimension(width, height)); 
            buttons[i][j] = xyUpsize((int) (width*factor[j]),
                                     (int) (height*factor[i]), 
                                     buttons[i][j]);
         }
    }
    JLabel msg = new JLabel(
"Verify: Width doubles as you move left-to-right & height doubles as you move top-to-bottom");
    Object[][] breadboard = {
         {buttons,      buttons,      buttons,      ySep()},
         {buttons,      buttons,      buttons,      ySep()},
         {buttons,      buttons,      buttons,      ySep()},
         {xSep(),       xSep(),       xSep(),       null},  
         {msg,          msg,          msg,          msg}
      };
      setBreadboard(breadboard);
   }
   public static void main(String[] args) {
	   showMessageBreadboard(null, new Test06Upsize(),"Test06Upsize()");
   }
 }
