
import javax.swing.*;

import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;

/** 
 ** Tests that array-mapped components invoke indexed getter/setter methods in the
 ** way that they are supposed to, for 0-D arrays. For JComponentBreadboard, a
 ** 0-D array is a 1 or 2 D array that has only a single array element.
 ** 
 **/ 
@SuppressWarnings("serial")
public class Test07ComponentArrays0D extends JComponentBreadboard {

   int disabledRowNum = 0;
   int disabledColNum = 0;
   JButton[] button = new JButton[1];

   public int getDisabledRow() {
      return disabledRowNum;
   }
   public void setDisabledRow(int row) {
      disabledRowNum = row;
   }
   
   public String getButtonText(int iRow) {
      String result = "iRow="+iRow;
      return result;
   }
   public void setButton(int iRow) {
      String msg = "<html><h1>" + (getButtonText(iRow).equals(button[iRow].getText()) ? "OK" : "Failed");
      showMessageBreadboard(this,
         new JComponentBreadboard(new Object[][] {
           {xAlign(1,new JLabel("<html><h1>The test result is:&nbsp;")), new JLabel(msg)}}),
         getButtonText(iRow));
   }

   public boolean getButtonEnabled(int iRow) {
      boolean result = (iRow != disabledRowNum);
      return result;
   }
   
   public Test07ComponentArrays0D() {
      JComponent disabledRow = new JSpinner(new SpinnerNumberModel(0, 0, 1, 1));
      for (int i = 0; i < 1; i++) {
            button[i] = new JButton();
      }

      JLabel msg = new JLabel(
"<html>Verify: Labels reflects col button is in<br> " +
"Disabled Row of spinner is disabled.<br>" +
"Clicking buttons shows OK (not Failed).");
      Object[][] breadboard = {
{xAlign(1,new JLabel("Disabled row: ")), xAlign(0,disabledRow), null, null}, 
         {xFill(button), button, button, button},  
         {msg,    msg,    msg,    msg}
      };
      setBreadboard(breadboard);
      jbConnect(button, "button");
      jbConnect(disabledRow, "disabledRow");
   }
   public static void main(String[] args) {
      showMessageBreadboard(null, new Test07ComponentArrays0D(), "Test07ComponentArrays0D()");   
   }
}
