
import javax.swing.*;

import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;

/** 
 ** Tests that array-mapped components invoke indexed getter/setter methods in the
 ** way that they are supposed to, for 2-D arrays
 ** 
 **/ 
@SuppressWarnings("serial")
public class Test07ComponentArrays2D extends JComponentBreadboard {

   int disabledRowNum = -1;
   int disabledColNum = -1;
   JComponent[][] button = new JButton[2][4];
   JComponent[][] oneRowOfButtons = new JButton[1][2];
   JComponent[][] oneColOfButtons = new JButton[2][1];
   JComponent[][] oneButton = new JButton[1][1];
   JComponent[][] zeroButton = new JButton[1][1];

   public int getDisabledRow() {
      return disabledRowNum;
   }
   public void setDisabledRow(int row) {
      disabledRowNum = row;
   }
   public int getDisabledCol() {
      return disabledColNum;
   }
   public void setDisabledCol(int col) {
      disabledColNum = col;
   }
   
   public String getButtonText(int iRow, int iCol) {
      String result = "iRow="+iRow+", iCol="+iCol;
      return result;
   }
   public void setButton(int iRow, int iCol) {
      String msg = "<html><h1>" + (getButtonText(iRow, iCol).equals(((JButton) button[iRow][iCol]).getText()) ? "OK" : "Failed");
      showMessageBreadboard(this,
         new JComponentBreadboard(new Object[][] {
           {xAlign(1,new JLabel("<html><h1>The test result is:&nbsp;")), new JLabel(msg)}}),
         getButtonText(iRow, iCol));
   }

   public boolean getButtonEnabled(int iRow, int iCol) {
      boolean result = ((iRow != disabledRowNum) && (iCol != disabledColNum));
      return result;
   }
   public void setOneButton(int iRow, int iCol) {
	      String msg = "<html><h1>" + ((iRow==0 && iCol==0) ? "OK" : "Failed");
	      showMessageBreadboard(this,
	         new JComponentBreadboard(new Object[][] {
	           {xAlign(1,new JLabel("<html><h1>The test result is:&nbsp;")), new JLabel(msg)}}),
	           "iRow, iCol = " + iRow + ", " + iCol);
	   }
   public void setOneRowOfButtons(int iRow, int iCol) {
	      String msg = "<html><h1>" + ((iRow == 0 && iCol <= 1) ? "OK" : "Failed");
	      showMessageBreadboard(this,
	         new JComponentBreadboard(new Object[][] {
	           {xAlign(1,new JLabel("<html><h1>The test result is:&nbsp;")), new JLabel(msg)}}),
	           "iRow, iCol = " + iRow + ", " + iCol);
	   }
   
   public void setOneColOfButtons(int iRow, int iCol) {
	      String msg = "<html><h1>" + ((iCol == 0 && iRow <= 1) ? "OK" : "Failed");
	      showMessageBreadboard(this,
	         new JComponentBreadboard(new Object[][] {
	           {xAlign(1,new JLabel("<html><h1>The test result is:&nbsp;")), new JLabel(msg)}}),
	           "iRow, iCol = " + iRow + ", " + iCol);
	   }
   
   public Test07ComponentArrays2D() {
      JComponent disabledRow = new JSpinner(new SpinnerNumberModel(-1, -1, 1, 1));
      JComponent disabledCol = new JSpinner(new SpinnerNumberModel(-1, -1, 3, 1));
      oneButton[0][0] = new JButton("One button");
      for (int i = 0; i < 2; i++) {
    	  oneColOfButtons[i][0] = new JButton("One Col, Row "+i);
    	  oneRowOfButtons[0][i] = new JButton("One Row, Col "+i);
      }
      for (int i = 0; i < 2; i++) {
         for (int j = 0; j < 4; j++) {
            button[i][j] = new JButton();
         }
      }
      JLabel msg = new JLabel(
"<html>Verify: Labels reflects row, col button is in<br> " +
"Disabled Row,Col of spinners are disabled.<br>" +
"Clicking buttons shows OK (not Failed).<br>" +
"One button spans first 2 cols, first 2 cols of last row empty,<br>" +
" one row buttons in last 2 cols, one col buttons in last 2 rows.");
      Object[][] breadboard = {
{xAlign(1,new JLabel("Disabled row: ")), xAlign(0,disabledRow), 
 xAlign(1, new JLabel("Disabled col: ")), xAlign(0,disabledCol)},
         {xFill(button), button, button, button},  
         {button, button, button, button},  
         {xyFill(oneButton), oneButton, oneRowOfButtons, oneRowOfButtons},  
         {oneButton, oneButton, oneRowOfButtons, oneRowOfButtons},  
         {oneButton, oneButton, oneRowOfButtons, oneRowOfButtons},  
         {oneButton, oneButton, xFill(oneColOfButtons), oneColOfButtons},
         {zeroButton, zeroButton, oneColOfButtons, oneColOfButtons},
         {msg,    msg,    msg,    msg}
      };
      setBreadboard(breadboard);
      jbConnect(button, "button");
      jbConnect(oneButton, "oneButton");
      jbConnect(oneRowOfButtons, "oneRowOfButtons");
      jbConnect(oneColOfButtons, "oneColOfButtons");
      jbConnect(disabledRow, "disabledRow");
      jbConnect(disabledCol, "disabledCol");
   }
   public static void main(String[] args) {
      showMessageBreadboard(null, new Test07ComponentArrays2D(), "Test07ComponentArrays2D()");   
   }
}
