
import java.awt.Color;
import java.util.Random;

import javax.swing.*;

import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;

/** 
 ** Tests JComponentBreadboard's JButton connectable properties
 ** 
 **/ 
@SuppressWarnings("serial")
public class Test08JButton extends JComponentBreadboard {
   private Random rnd = new Random();
   Color[] color = {Color.BLUE, Color.CYAN, Color.DARK_GRAY, Color.GRAY,
		   Color.GREEN, Color.LIGHT_GRAY, Color.MAGENTA, Color.ORANGE,
		   Color.PINK, Color.RED, Color.YELLOW};
   Color defForeground;
   Color defBackground;
   int count = 0;
   boolean isEnabled = true;
   boolean isVisible = true;
   boolean isDefault = true;
   public void setButton() {
      count++;
   }
   public String getButtonText() { return "Number of clicks = " + count;}
   public boolean getButtonEnabled() {return isEnabled;}
   public boolean getButtonVisible() {return isVisible;}
   public String getButtonToolTipText() {return count + " clicks since app started.";}
   public Color getButtonForeground() {
	   int i = rnd.nextInt(color.length);
	   Color result = color[i];
	   if (Math.random() < 0.5)
		  result = defForeground;
      return result;
  }
   public Color getButtonBackground() {
	   int i = rnd.nextInt(color.length);
	   Color result = color[i];
	   if (Math.random() < 0.5)
		  result = defBackground;
      return result;
   }
   public boolean getButtonIsDefaultButton() {return isDefault;}
   public void setEnabled(boolean isEnabled) {this.isEnabled = isEnabled;}
   public boolean getEnabled() {return isEnabled;}
   
   public void setVisible(boolean isVisible) {this.isVisible = isVisible;}
   public boolean getVisible() {return isVisible;}

   public void setDefaultButton(boolean isDefault) {this.isDefault = isDefault;}
   public boolean getDefaultButton() {return isDefault;}
  
   
   public Test08JButton() {
      JComponent button = xyFill(new JButton());
      defBackground = button.getBackground();
      defForeground = button.getForeground();
      JCheckBox enabled = new JCheckBox("Enabled (unchecking should disable button)");
      JCheckBox visible = new JCheckBox("Visible (unchecking should hide button)");
      JCheckBox defaultButton = new JCheckBox("Default button");
      
      JLabel msg = new JLabel(
"<html>Verify: Clicking button increments label, tooltip, changes fore/back colors. <br>" +
"Default button checked makes Return click. Enable, visible working.");
      Object[][] breadboard = {
         {null,        enabled,       visible},
         {null,        defaultButton, defaultButton},
         {ySpace(100), button,        button},
         {msg,         msg,           msg}
      };
      setBreadboard(breadboard);
      jbConnect(button, "button");
      jbConnect(enabled, "enabled");
      jbConnect(visible, "visible");
      jbConnect(defaultButton, "defaultButton");
   }
   public static void main(String[] args) {
	   showMessageBreadboard(null, new Test08JButton(),"Test08JButton()");
   }

 }
