
import javax.swing.*;

import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;

/** 
 ** Tests JComponentBreadboard's JCheckBox, JRadioButton, 
 ** and JToggleButton connectable properties (all are JToggleButtons,
 ** and JComponentBreadboard's jbConnect treats them the same).
 ** 
 **/
@SuppressWarnings("serial")
public class Test09ToggleButton extends JComponentBreadboard {
   boolean isChecked = true;
   boolean isEnabled = true;
   boolean isVisible = true;
   
   public void setCheckbox(boolean isChecked) {this.isChecked = isChecked;}
   public boolean getCheckbox() {return isChecked;}

   public String getCheckboxText() { return "isChecked="+isChecked;}
   public boolean getCheckboxEnabled() {return isEnabled;}
   public boolean getCheckboxVisible() {return isVisible;}
   public String getCheckboxToolTipText() {return "isChecked="+isChecked;}

   public void setEnabled(boolean isEnabled) {this.isEnabled = isEnabled;};
   public boolean getEnabled() {return isEnabled;};
   
   public void setVisible(boolean isVisible) {this.isVisible = isVisible;};
   public boolean getVisible() {return isVisible;};
   
   public Test09ToggleButton(int mode) {
      JComponent checkbox = null;
      if (0 == mode)
        checkbox = xAlign(0.5,new JCheckBox());
      else if (1 == mode)
        checkbox = xAlign(0.5,new JRadioButton());
      else if (2 == mode)   
         checkbox = xAlign(0.5,new JToggleButton());
      
      JCheckBox enabled = new JCheckBox("Enabled (unchecking should disable checkbox)");
      JCheckBox visible = new JCheckBox("Visible (unchecking should hide checkbox)");
      
      JLabel msg = new JLabel(
"Verify: Clicking button changes labels and tooltip. Enable, visible checkboxes working.");
      Object[][] breadboard = {
         {null,        enabled,                  visible},
         {ySpace(100), checkbox,                 checkbox},
         {msg,         msg,                       msg}
      };
      setBreadboard(breadboard);
      jbConnect(checkbox, "checkbox");
      jbConnect(enabled, "enabled");
      jbConnect(visible, "visible");
 
   }
   public static void main(String[] args) {
	   showMessageBreadboard(null, new Test09ToggleButton(0),"Test09ToggleButton(0)");
	   showMessageBreadboard(null, new Test09ToggleButton(1),"Test09ToggleButton(1)");
	   showMessageBreadboard(null, new Test09ToggleButton(2),"Test09ToggleButton(2)");
   }
 }
