
import javax.swing.*;

import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;

/** 
 ** Tests JCComponentBreadboard's JComboBox support.
 ** 
 **/
@SuppressWarnings("serial")
public class Test10JComboBox extends JComponentBreadboard {
   boolean isEnabled = true;
   boolean isVisible = true;
   boolean isEditable = true;
   String  selection = "Some initial junk";
   
   public void setCombobox(String selection) {
	   this.selection = selection;
   }
   public String getCombobox() {return selection;}

   public boolean getComboboxEnabled() {return isEnabled;}
   public boolean getComboboxVisible() {return isVisible;}
   public String getComboboxToolTipText() {return "selection="+getCombobox();}

   public String[] getComboboxItems() {
      return new String[] {isEditable ? "A (editable)" : "A",
      isEditable ? "B (editable)" : "B"};
   }

   public boolean getComboboxEditable() {return isEditable;}

   public String getComboboxInvalidDataMessage(String entry) {
      String result = JComponentBreadboard.DATA_IS_VALID;
      if (entry.matches("[0-9]+"))
         result = "Integer entries are not allowed. Enter something else.";
      return result;
   }
   
   public void setEnabled(boolean isEnabled) {this.isEnabled = isEnabled;};
   public boolean getEnabled() {return isEnabled;};
   
   public void setVisible(boolean isVisible) {this.isVisible = isVisible;};
   public boolean getVisible() {return isVisible;};

   public void setEditable(boolean isEditable) {this.isEditable = isEditable;};
   public boolean getEditable() {return isEditable;};

   public String getSelectedText() { return getCombobox(); }
   
   public Test10JComboBox() {
      JComboBox combobox = new JComboBox();      
      JCheckBox enabled = new JCheckBox("Enabled (unchecking should disable checkbox)");
      JCheckBox visible = new JCheckBox("Visible (unchecking should hide checkbox)");
      JCheckBox editable = new JCheckBox("Editable (unchecked ==> not editable)");
      JLabel selected = new JLabel();
      
      JLabel msg = new JLabel("<html>" +
"Verify: Combobox changes label & tooltip. Enable, visible, editable checkboxes work.<br>" +
"Entering an integer produces an error pop-up." );
      JComponent sp = ySpace(100);
      Object[][] breadboard = {
         {null,        enabled,                  visible},
         {null,        editable,                 editable},
         {xSep(),      xSep(),                   xSep() },
         {sp,          yAlign(.5,combobox),     selected},
         {xSep(),      xSep(),                   xSep() },
         {msg,         msg,                       msg}
      };
      setBreadboard(breadboard);
      jbConnect(combobox, "combobox");
      jbConnect(selected, "selected");
      jbConnect(enabled, "enabled");
      jbConnect(visible, "visible");
      jbConnect(editable, "editable");
 
   }
   public static void main(String[] args) {
	   showMessageBreadboard(null, new Test10JComboBox(),"Test10JComboBox()");
   }
 }
