
import java.awt.Color;
import java.awt.Insets;

import javax.swing.*;

import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;

/** 
 ** Tests JComponentBreadboard's JTextComponent connectable properties
 ** 
 **/ 
@SuppressWarnings("serial")
public class Test12JTextComponent extends JComponentBreadboard {
   String jtc = "";
   boolean isEnabled = true;
   boolean isVisible = true;
   boolean isEditable = true;
   public void setJtc(String pwd) {
      this.jtc = pwd;
   }
   public String getJtc() { return jtc;}
   public boolean getJtcEnabled() {return isEnabled;}
   public boolean getJtcVisible() {return isVisible;}
   public String getJtcToolTipText() {return
         "Your last entered string was \"" + jtc + "\"";}

   public Color getJtcDisabledTextColor() {
      return Color.GREEN;
   }
   public Color getJtcSelectedTextColor() {
      return Color.BLUE;
   }
   public Color getJtcSelectionColor() {
      return Color.RED;
   }
   public boolean getJtcEditable() {
      return isEditable;
   }

   public Insets getJtcMargin() {
      return new Insets(20, 20, 20, 20);
   }

   public String getJtcInvalidDataMessage(String message) {
      String result = JComponentBreadboard.DATA_IS_VALID;

      if (message.matches("[0-9]"))
         result = JComponentBreadboard.REVERT_QUIETLY; 
      else if (message.matches("[0-9][0-9]"))
         result = JComponentBreadboard.REVERT_AND_BEEP; 
      else if (message.matches("[0-9][0-9][0-9]"))
         result = "3-digit positive integers are invalid. " +
                  "Try something longer, or a non-integer.";
      else if (message.matches("[0-9][0-9][0-9][0-9]"))
         result = "<title>4 Digit Title</title>4 digits are bad, too.";      
      else if (message.matches("[0-9][0-9][0-9][0-9][0-9]"))
          result = "Sorry but <TITLE>5 Digit Title</TITLE>5 digits are bad, too.";      
      return result;
   }
   
   public void setEnabled(boolean isEnabled) {this.isEnabled = isEnabled;}
   public boolean getEnabled() {return isEnabled;}
   
   public void setVisible(boolean isVisible) {this.isVisible = isVisible;}
   public boolean getVisible() {return isVisible;}

   public void setEditable(boolean isEditable) {this.isEditable = isEditable;}
   public boolean getEditable() {return isEditable;}

   

   public String getLbl() {return jtc;}


   public void setOk() { jbReturn(); }
   
   public Test12JTextComponent(int mode) {
      JComponent jtc = null;
      switch(mode) {
        case 0:
    	   jtc = new JPasswordField(10);
    	   break;
        case 1:
           jtc = new JTextField(10);
           break;
        case 2:
            jtc = new JTextArea(2,10);
            break;
        case 3:
            jtc = new JEditorPane();
            break;
        	           
      }
      JComponent lbl = xyFill(new JLabel());
      
      JCheckBox enabled = new JCheckBox("Enabled (unchecking should disable component)");
      JCheckBox visible = new JCheckBox("Visible (unchecking should hide component)");
      JCheckBox editable = new JCheckBox("Editable (unchecking disable editing)");
      
      JLabel msg = new JLabel(
"<html>Verify: Entry shown on label, tooltips. 20 pix margins. " +
"<br>Verify: GREEN, BLUE, RED, disabled, selected, selected-text. " +
"<br>Verify: Enable, visible, editable checkboxes work. " + 
"<br>Verify: 1=>REVERT_QUIETLY; 22 digit=>REVERT_AND_BEEP; 333=>popup error message." + 
"<br>Verify: 4444 - 4 Digit Title in error pop-up; 55555 - 5 Digit Title in error popup.");
      JComponent sp = ySpace(100);
      Object[][] breadboard = {
         {null,        enabled, visible},
         {null,        editable, editable},
         {ySpace(50),  null,    null},
         {sp,          xAlign(1,new JLabel("Enter something: ")),     xAlign(0,jtc)},
         {sp,          null,     lbl},
         {ySpace(50),  null,    null},
         {msg,         msg,     msg}
      };
      setBreadboard(breadboard);
      jbConnect(jtc, "jtc");
      jbConnect(lbl, "lbl");
      jbConnect(enabled, "enabled");
      jbConnect(visible, "visible");
      jbConnect(editable, "editable");
//      jbConnect(CLOSE_BUTTON, "ok");

   }
   public static void main(String[] args) {
	   showMessageBreadboard(null, new Test12JTextComponent(0),"Test12JTextComponent(0)");
	   showMessageBreadboard(null, new Test12JTextComponent(1),"Test12JTextComponent(1)");
	   showMessageBreadboard(null, new Test12JTextComponent(2),"Test12JTextComponent(2)");
	   showMessageBreadboard(null, new Test12JTextComponent(3),"Test12JTextComponent(3)");
   }
 }
