


import javax.swing.*;

import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;

/** 
 ** Tests JComponentBreadboard's JButton connectable properties
 ** 
 **/ 
@SuppressWarnings("serial")
public class Test14JScrollBar extends JComponentBreadboard {
   int jsb = 100;
   boolean isEnabled = true;
   boolean isVisible = true;


//
// REQUIRED 'jbConnect(myJScrollBar,"jsb")' implied methods:
   public int getJsb() {return jsb;}
   public void setJsb(int jsb) {this.jsb = jsb;}
//
// OPTIONAL 'jbConnect(myJScrollBar,"jsb")' implied methods:
   public boolean getJsbEnabled() { return isEnabled; }
   public boolean getJsbVisible() { return isVisible; }
   public String getJsbToolTipText() {return "Scroll position = " + jsb;}
//   public Color getJsbForeground() {}
//   public Color getJsbBackground() {}
   public int getJsbMinimum() { return 100;}  // just use some non-default values
   public int getJsbMaximum() { return 1600;} // so we can be sure they got in there
   public int getJsbUnitIncrement() {return 100;}    //10% of range
   public int getJsbBlockIncrement() {return 500;}  // 50% of range
   public int getJsbVisibleAmount() {return 500;}   // 50% of range
   
   public void setEnabled(boolean isEnabled) {this.isEnabled = isEnabled;}
   public boolean getEnabled() {return isEnabled;}
   
   public void setVisible(boolean isVisible) {this.isVisible = isVisible;}
   public boolean getVisible() {return isVisible;}

   public String getLblText() {return "Scroll position = " + jsb;}
   
   public Test14JScrollBar() {
      JComponent jsb = new JScrollBar(JScrollBar.HORIZONTAL);

      JComponent lbl = xAlign(0.5,new JLabel());
      
      JCheckBox enabled = new JCheckBox("Enabled (unchecking should disable component)");
      JCheckBox visible = new JCheckBox("Visible (unchecking should hide component)");
      
      JLabel msg = new JLabel(
"<html>Verify: Scroll extent: min,max = 100, 1100; Thumb extent 1/3rd of bar." +
"<br>Verify: Bar-click generates +/- 500 (50%), Arrow-click generates +/- 100 (10%)" +
"<br>Verify: Label, scrollbar tooltip, and enable, visible checkboxes work.");
      JComponent sp = ySpace(100);
      Object[][] breadboard = {
         {null,         xSpace(100), xSpace(100)},
         {null,        enabled,     visible},
         {ySpace(50),  null,        null},
         {sp,          jsb,         jsb},
         {sp,          lbl,        lbl},
         {ySpace(50),  null,        null},
         {msg,         msg,         msg}
      };
      setBreadboard(breadboard);
      jbConnect(jsb, "jsb");
      jbConnect(lbl, "lbl");
      jbConnect(enabled, "enabled");
      jbConnect(visible, "visible");
   }
   public static void main(String[] args) {
	   showMessageBreadboard(null, new Test14JScrollBar(),"Test14JScrollBar()");
   }
 }
