

import java.util.Dictionary;
import java.util.Hashtable;

import javax.swing.*;

import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;

/** 
 ** Tests JComponentBreadboard's JButton connectable properties
 ** 
 **/ 
@SuppressWarnings("serial")
public class Test15JSlider extends JComponentBreadboard {
   int js = 50;
   boolean isEnabled = true;
   boolean isVisible = true;
   boolean isInverted = true;
   boolean paintLabels = true;
   boolean paintTicks = true;
   boolean paintTrack = true;
   boolean snapToTicks = true;
   
//
// REQUIRED 'jbConnect(myJSlider,"js")' implied methods:
   public int getJs() { return js;}
   public void setJs(int value) {js = value;}
//
// OPTIONAL 'jbConnect(myJSlider,"js")' implied methods:
   public boolean getJsEnabled() {return isEnabled; }
   public boolean getJsVisible() {return isVisible;}
   public String getJsToolTipText() {return "Slider position = " + js;}
//   public Color getJsForeground() {}
//   public Color getJsBackground() {}
   public int getJsExtent() {return 0;}
   public boolean getJsInverted() {return isInverted;}
   public Dictionary getJsLabelTable() {
      Hashtable<Integer,JComponent> result = new Hashtable<Integer,JComponent>();
      for (int i = 10; i <= 110; i+=10) {
         result.put(new Integer(i), new JLabel("<html><i><b>" + i));
      }
      return result;
   }
   public int getJsMajorTickSpacing() { return 10;}
   public int getJsMaximum() {return 110;}
   public int getJsMinimum() {return 10;}
   public int getJsMinorTickSpacing() {return 5;}
   public boolean getJsPaintLabels() {return paintLabels;}
   public boolean getJsPaintTicks() { return paintTicks;}
   public boolean getJsPaintTrack() { return paintTrack;}
   public boolean getJsSnapToTicks() {return snapToTicks;}

   public void setEnabled(boolean isEnabled) {this.isEnabled = isEnabled;}
   public boolean getEnabled() {return isEnabled;}

   public void setVisible(boolean isVisible) {this.isVisible = isVisible;}
   public boolean getVisible() {return isVisible;}

   public String getLblText() {return "Slider position = " + js;}
   
   public Test15JSlider() {
      JComponent js = new JSlider(JSlider.HORIZONTAL);
      JComponent lbl = xAlign(0.5,new JLabel());
      
      JCheckBox enabled = new JCheckBox("Enabled (unchecking should disable component)");
      JCheckBox visible = new JCheckBox("Visible (unchecking should hide component)");
      JCheckBox inverted = new JCheckBox("Inverted (checking reverses slider orientation)");
      JCheckBox paintLabels = new JCheckBox("Paint labels on slider");
      JCheckBox paintTicks = new JCheckBox("Paint ticks on slider");
      JCheckBox paintTrack = new JCheckBox("Paint track on slider");
      JCheckBox snapToTicks = new JCheckBox("Snap to ticks on slider");
      
      JLabel msg = new JLabel(
"<html>Verify: Bold, italic labels from 10 to 110. " +
"<br>Verify: Minor ticks every 5, majors every 10." +
"<br>Verify: Slider label and tooltip; all checkboxes work.");
      JComponent sp = ySpace(100);
      Object[][] breadboard = {
         {null,         xSpace(100), xSpace(100)},
         {null,        enabled,     visible},
         {null,        inverted,    paintLabels},
         {null,        paintTicks,  paintTrack},
         {null,        snapToTicks, null},
         {ySpace(50),  null,        null},
         {sp,          js,          js},
         {sp,          lbl,         lbl},
         {ySpace(50),  null,        null},
         {msg,         msg,         msg}
      };
      setBreadboard(breadboard);
      jbConnect(js, "js");
      jbConnect(lbl, "lbl");
      jbConnect(enabled, "enabled");
      jbConnect(visible, "visible");
      jbConnect(inverted, "inverted");
      jbConnect(paintLabels, "paintLabels");
      jbConnect(paintTicks, "paintTicks");
      jbConnect(paintTrack, "paintTrack");
      jbConnect(snapToTicks, "snapToTicks");
   }
   public static void main(String[] args) {
	   showMessageBreadboard(null, new Test15JSlider(),"Test15JSlider()");
   }
public boolean isInverted() {
	return isInverted;
}
public void setInverted(boolean isInverted) {
	this.isInverted = isInverted;
}
public boolean isPaintLabels() {
	return paintLabels;
}
public void setPaintLabels(boolean paintLabels) {
	this.paintLabels = paintLabels;
}
public boolean isPaintTicks() {
	return paintTicks;
}
public void setPaintTicks(boolean paintTicks) {
	this.paintTicks = paintTicks;
}
public boolean isPaintTrack() {
	return paintTrack;
}
public void setPaintTrack(boolean paintTrack) {
	this.paintTrack = paintTrack;
}
public boolean isSnapToTicks() {
	return snapToTicks;
}
public void setSnapToTicks(boolean snapToTicks) {
	this.snapToTicks = snapToTicks;
}
 }
