
import java.awt.Color;
import java.util.Date;
import java.util.GregorianCalendar;

import javax.swing.*;

import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;


/** 
 ** Test's JComponentBreadboard's spinner support
 **/
@SuppressWarnings("serial")
public class Test16Spinner extends JComponentBreadboard {
   int intValue = 200;
   Date dateValue = new GregorianCalendar(2005,0,1).getTime();
   String listValue = "XXXX";
   double numberValue = 20.0;
   boolean isEnabled = true;
   boolean isVisible = true;

// REQUIRED 'jbConnect(myJSpinner,"spinner")' implied methods:
   public int getSpinner1() { return intValue; }
   public void setSpinner1(int value) {this.intValue = value;}

//
// OPTIONAL 'jbConnect(myJSpinner,"spinner")' implied methods:
   public boolean getSpinner1Enabled() {return isEnabled;}
   public boolean getSpinner1Visible() {return isVisible;}
   public String getSpinner1ToolTipText() {return "The value is: " + intValue;}
   public Color getSpinner1Foreground() { return Color.RED;}
   public Color getSpinner1Background() {return Color.YELLOW;}

   public int getSpinner1Minimum() {return 1;}
   public int getSpinner1Maximum() {return 1000;}
   public int getSpinner1StepSize() {return 100;}


//
// REQUIRED 'jbConnect(myJSpinner,"spinner2")' implied methods:
//   public Date getSpinner2() {}
//   public void setSpinner2(Date value) {}
//
   public Date getSpinner2() { return dateValue; }
   public void setSpinner2(Date value) {this.dateValue = value;}
// OPTIONAL 'jbConnect(myJSpinner,"spinner2")' implied methods:
   public boolean getSpinner2Enabled() {return isEnabled;}
   public boolean getSpinner2Visible() {return isVisible;}
   public String getSpinner2ToolTipText() {return "Value = " + dateValue;}
   public Color getSpinner2Foreground() {return Color.RED;}
   public Color getSpinner2Background() {return Color.YELLOW;}

   public Date getSpinner2Start() {return  new GregorianCalendar(2000,0,1).getTime();}
   public Date getSpinner2End() {return  new GregorianCalendar(2010,0,1).getTime();}


   public String getSpinner3() { return listValue; }
   public void setSpinner3(String value) {this.listValue = value;}
//
// REQUIRED 'jbConnect(myJSpinner,"spinner3")' implied methods:
//   public String getSpinner3() {}
//   public void setSpinner3(String value) {}
//
// OPTIONAL 'jbConnect(myJSpinner,"spinner3")' implied methods:
   public boolean getSpinner3Enabled() {return isEnabled;}
   public boolean getSpinner3Visible() {return isVisible;}
   public String getSpinner3ToolTipText() {return "Value = "+listValue;}
   public String[] getSpinner3Items() {
      String[] result =  {"WWWW", "XXXX", "YYYY", "ZZZZZZZZ"};
      return result;
   }


//
// REQUIRED 'jbConnect(myJSpinner,"spinner4")' implied methods:
//   public double getSpinner4() {}
//   public void setSpinner4(double value) {}
//
// OPTIONAL 'jbConnect(myJSpinner,"spinner4")' implied methods:
//   public boolean getSpinner4Enabled() {}
//   public boolean getSpinner4Visible() {}
//   public String getSpinner4ToolTipText() {}
//   public double getSpinner4Minimum() {}
//   public double getSpinner4Maximum() {}
//   public double getSpinner4StepSize() {}
//   public Color getSpinner4Foreground() {}
   //   public Color getSpinner4Background() {}
   public boolean getSpinner4Enabled() {return isEnabled;}
   public boolean getSpinner4Visible() {return isVisible;}
   public String getSpinner4ToolTipText() {return "The value is: " + numberValue;}
   public Color getSpinner4Foreground() { return Color.RED;}
   public Color getSpinner4Background() {return Color.YELLOW;}
   public double getSpinner4Minimum() {return -100;}
   public double getSpinner4Maximum() {return 100;}
   public double getSpinner4StepSize() {return 10;}
   public double getSpinner4() { return numberValue; }
   public void setSpinner4(double value) {
	   this.numberValue = value;
   }
   
//   public Color getSpinner3Foreground() {}
   //   public Color getSpinner3Background() {}
   public void setEnabled(boolean isEnabled) {this.isEnabled = isEnabled;};
   public boolean getEnabled() {return isEnabled;};
   
   public void setVisible(boolean isVisible) {this.isVisible = isVisible;};
   public boolean getVisible() {return isVisible;};

   public String getDateValueText() {return "dateValue="+dateValue;}
   public String getNumberValueText() {return "numberValue="+numberValue;}
   public String getIntValueText() {return "intValue="+intValue;}
   public String getListValueText() {return "listValue="+listValue;}
   
   public Test16Spinner() {
	  // the Swing default, no-arg, spinner is an integer spinner 
      JComponent spinner1 = xyAlign(1,1,new JSpinner());
      JComponent spinner2 = xyAlign(1,1,new JSpinner(new SpinnerDateModel()));
      JComponent spinner3 = xyAlign(1,1,new JSpinner(new SpinnerListModel()));
      JComponent spinner4 = xyAlign(1, 1, new JSpinner(new
                            SpinnerNumberModel(1.0, 0.0, 1000.0, 100.0)));

      JCheckBox enabled = new JCheckBox("Enabled (unchecking should disable checkbox)");
      JCheckBox visible = new JCheckBox("Visible (unchecking should hide checkbox)");
      
      JLabel msg = new JLabel(
"<html>Verify: Integer Initially 200 spins from 100 to 1000 by 100 " +
"<br>Verify: Date initially 1/1/2005 spins from 1/1/2000 to 1/1/2010 " +
"<br>Verify: List initially XXXX spins over  WWWW, XXXX, YYYY, and ZZZZZZZZ " +
"<br>Verify: Double intially 20 spins from -100 to 100 by 10 " +
"<br>Enable, visible checkboxes working. Labels, tooltips reflect spinner state.");
      JComponent numberLbl = xyAlign(1,0,new JLabel());
      JComponent dateLbl = xyAlign(1,0,new JLabel());
      JComponent intLbl = xyAlign(1,0,new JLabel());
      JComponent listLbl = xyAlign(1,0,new JLabel());
 
      Object[][] breadboard = {
    	 {null,    NOSCALE,          EXPANDS,                  EXPANDS},	  
         {NOSCALE, null,             enabled,                  visible},
         {NOSCALE, xySpace(10,50),   spinner1,                spinner2},
         {NOSCALE, ySpace(50),       intLbl,                  dateLbl},
         {NOSCALE, ySpace(50),       spinner3,                 spinner4},
         {NOSCALE, ySpace(50),       listLbl,                 numberLbl},
         {NOSCALE, msg,         msg,                       msg}
      };
      setBreadboard(breadboard);
      jbConnect(intLbl, "intValue");
      jbConnect(numberLbl, "numberValue");
      jbConnect(dateLbl, "dateValue");
      jbConnect(listLbl, "listValue");

      jbConnect(spinner1, "spinner1");
      jbConnect(spinner2, "spinner2");
      jbConnect(spinner3, "spinner3");
      jbConnect(spinner4, "spinner4");
      jbConnect(enabled, "enabled");
      jbConnect(visible, "visible");
 
   }
   public static void main(String[] args) {
	   showMessageBreadboard(null, new Test16Spinner(),"Test16Spinner()");
   }
 }
