


import javax.swing.*;

import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;

/** 
 ** Tests JComponentBreadboard's jbRun and progresss cancel feedback facilities
 ** 
 **/ 
@SuppressWarnings("serial")
public class Test17JbRun extends JComponentBreadboard {
   // does not have to be a million, use any number that makes 
  // progress at a good speed	
   private final long MILLION = 50000000;
   long sum = 0;
   private boolean canBeCanceled = true;
   private boolean indeterminate = false;
   private String nStages = "2";
   
   private boolean sumToAMillion() {
      boolean result = true;
      for (long i = 0; i <= MILLION; i++) {
         sum += i;
         
         if (!indeterminate) setJbRunProgress(((double) i)/MILLION);
 //        jbRunRefresh();  
         if (getJbRunCanceled()) {
            result = false;
            break;
         }
      }
      return result;
   }

   private void twoStageSum() {
         sum = 0;
         jbRunRefresh();
         setJbRunNote("Stage 1 Stage 1 Stage 1 Stage 1 Stage 1 Stage 1 Stage 1 Stage 1 Stage 1 Stage 1 Stage 1 ");
        
         beginProgressMonitoredSection(0, 0.25);
         if (!sumToAMillion()) {
            endProgressMonitoredSection();	 
            sum = 0;
         }
         else {
           endProgressMonitoredSection();	 
           if (!getJbRunCanceled() && !indeterminate && nStages.equals("2") && 4*getJbRunProgressGlobally() != 1)
               throw new IllegalStateException("getJbRunProgressGlobally not 1/4.");
           
           jbRunRefresh(); 
           setJbRunNote("Stage 2 Stage 2 Stage 2 Stage 2 Stage 2 Stage 2 Stage 2 Stage 2 Stage 2 Stage 2 ");
           beginProgressMonitoredSection(0.25, 1.0);	 
           if (!sumToAMillion()) sum = 0;
           endProgressMonitoredSection();	 
           if (!getJbRunCanceled() && !indeterminate && nStages.equals("2") && getJbRunProgressGlobally() != 1)
              throw new IllegalStateException("getJbRunProgressGlobally not 1.");
         }
   }
   
   public void setButton() {
      setJbRunNote("<html>");
      setJbRunNoteDelimiter("<br>");
      if (getIndeterminate()) 
    	  setJbRunProgress(Double.NaN);
      else
    	  setJbRunProgress(0);
    	  
      jbRun(new Runnable() { public void run() {
    	 if (getIndeterminate()) setJbRunRefreshInterval(100); 
         setJbRunTitle("jbRun Test, nStages=" + nStages);
         setJbRunCanBeCanceled(canBeCanceled);
         System.out.println(getJbRunNoteGlobally());
         if (nStages.equals("4")) {
            setJbRunNote("Part 1 of 2 Part 1 of 2 Part 1 of 2 Part 1 of 2 Part 1 of 2 Part 1 of 2 Part 1 of 2 Part 1 of 2 Part 1 of 2 Part 1 of 2 Part 1 of 2 ");
            System.out.println(getJbRunNoteGlobally());
            beginProgressMonitoredSection(0, .5);
                  twoStageSum();
            endProgressMonitoredSection();
            setJbRunNote("Part 2 of 2 Part 2 of 2 Part 2 of 2 Part 2 of 2 Part 2 of 2 Part 2 of 2 Part 2 of 2 Part 2 of 2 Part 2 of 2 Part 2 of 2 ");
            beginProgressMonitoredSection(0.5, 1);
                  twoStageSum();
            endProgressMonitoredSection();
         }
         else if (nStages.equals("2"))
            twoStageSum();
         else {
            sum = 0;
            jbRunRefresh();
            sumToAMillion();
         }
     }});
      
   }

   public boolean getCanBeCanceled() {
      return canBeCanceled;
   }
   public void setCanBeCanceled(boolean canBeCanceled) {
      this.canBeCanceled = canBeCanceled;
   }
   public boolean getIndeterminate() {
	      return indeterminate;
	   }
	   public void setIndeterminate(boolean indeterminate) {
	      this.indeterminate = indeterminate;
	   }
   public String getNStages() {
      return nStages;
   }
   public void setNStages(String nStages) {
      this.nStages = nStages;
   }
   
   public String getLabelText() { 
//	   String result = "Sum = " + sum;
     String result = ((MILLION*(MILLION+1)) <= sum) ?
         "Two Million or more summed" : (MILLION*(MILLION + 1) <= 2*sum) ? "One Million or more summed" :
         "Less than one million summed.";
	   return result;
   }
   public Test17JbRun() {
      JComponent button = xyFill(new JButton("Start Test"));
      JComponent label = new JLabel();
      JComponent canBeCanceled = xAlign(1, new JCheckBox("Can be canceled"));   
      JComponent indeterminate = xAlign(1, new JCheckBox("Indeterminate"));   
      JComponent nStages = xAlign(0, new JComboBox(new String[] {"1","2","4"}));   
       JLabel msg = new JLabel(
"<html>Verify: 1,2, 4 stages work. 4 Stage looks like two 2-stages in sequence." +
"<br>Label gets updated from lt Million to gt Million to gt 2 Million as stage 1,2 progress." +
"<br>Cancel button works." +
"<br>Stage 1 maps to initial 1/4th of bar and moves slowest." +
"<br>Stage 2 maps to final 3/4th of bar and moves 3 times faster." +
"<br>Cancel, canBeCanceled checkbox both work.");
      Object[][] breadboard = {
         {null,        label,                                   canBeCanceled},
         {null,        label,                                   indeterminate},
         {null,        xAlign(1,new JLabel("Stages: ")),        nStages},
         {ySpace(200), button,                                  button},
         {null,        msg,                                     msg }
      };
      setBreadboard(breadboard);
      jbConnect(button, "button");
      jbConnect(label, "label");
      jbConnect(canBeCanceled, "canBeCanceled");
      jbConnect(indeterminate, "indeterminate");
      jbConnect(nStages, "nStages");
   }
   public static void main(String[] args) {
	   showMessageBreadboard(null, new Test17JbRun(),"Test17JbRun()");
   }

 }
