
import javax.swing.*;

import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;

/** 
 ** Tests the ability to connect KeyStroke objects via jbConnect ("hot
 ** keys")--both individual KeyStroke connections and 1 and 2 D arrays
 ** of KeyStrokes. 
 ** 
 **/ 
@SuppressWarnings("serial")
public class Test19HotKeys extends JComponentBreadboard {

   boolean keysDisabled = false;
   KeyStroke[] array1D = {KeyStroke.getKeyStroke("RIGHT"),
           KeyStroke.getKeyStroke("ESCAPE"),
           KeyStroke.getKeyStroke("UP"),
           KeyStroke.getKeyStroke("F1"),
           KeyStroke.getKeyStroke("shift ctrl alt released HOME"),
           KeyStroke.getKeyStroke("DOWN")};
KeyStroke[][] array2D = {
{KeyStroke.getKeyStroke("HOME"), KeyStroke.getKeyStroke("shift HOME")},
{KeyStroke.getKeyStroke("END"), KeyStroke.getKeyStroke("shift END")}
};
   public boolean getKeysDisabled() {
      return keysDisabled;
   }
   public void setKeysDisabled(boolean disabled) {
      keysDisabled = disabled;
   }

   public void keyAction(KeyStroke ks) {
      String msg = "<html><h1>" + ks.toString();
      showMessageBreadboard(this,
         new JComponentBreadboard(new Object[][] {
           {xAlign(1,new JLabel("<html><h1>Check that you pressed:&nbsp;")), new JLabel(msg)}}),
           "Hot key response");
   }
   public void setLeft() {
	   keyAction(KeyStroke.getKeyStroke("LEFT"));
   }
   public boolean getLeftEnabled() {
      return !keysDisabled;
   }
   
   public void setArray1D(int iRow) {
      keyAction(array1D[iRow]);
   }

   public boolean getArray1DEnabled(int iRow) {
      return !keysDisabled;
   }
   
   public void setArray2D(int iRow, int iCol) {
      keyAction(array2D[iRow][iCol]);
   }

   public boolean getArray2DEnabled(int iRow, int iCol) {
      return !keysDisabled;
   }
   
   public Test19HotKeys() {
      JComponent keysDisabled = new JCheckBox("Disable all hot keys");
      JLabel msg = new JLabel(
"<html>Verify: Keys Left, Right, Up, Down, HOME, END, SHIFT-HOME, SHIFT-END respond. <br>" +
"<br>And do not respond if disabled is checked");
      Object[][] breadboard = {
         {keysDisabled},
         {msg}
      };
      setBreadboard(breadboard);
      jbConnect(keysDisabled, "keysDisabled");
      jbConnect(KeyStroke.getKeyStroke("LEFT"), "left");
      jbConnect(array1D, "array1D");
      jbConnect(array2D, "array2D");
      
   }
   public static void main(String[] args) {
      showMessageBreadboard(null, new Test19HotKeys(), "Test19HotKeys()");   
   }
}
