
import java.awt.Dimension;
import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.border.LineBorder;

import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;

/** 
 ** Tests the getPreferredSize auxiliary property of a variety of JComponents
 ** 
 **/ 
@SuppressWarnings("serial")
public class Test20PreferredSize extends JComponentBreadboard {
   boolean isLandscape = false;
   public Dimension getXPreferredSize() {
      if (isLandscape)
         return new Dimension(100, 50);
      else
         return new Dimension(50, 100);
   }

   public Dimension getPanelPreferredSize() {
	   return getXPreferredSize();	   
   }
   public Border getPanelBorder() {
      return LineBorder.createBlackLineBorder();
   }
   public void setButton() {return;}
   public Dimension getButtonPreferredSize() {
	   return getXPreferredSize();
   }
   private int iSpinner = 1;
   public int getSpinner() {return iSpinner;}
   public void setSpinner(int value) {iSpinner = value;}
   public Dimension getSpinnerPreferredSize() { return getXPreferredSize();}

   String sCombo = "A";
   public String getCombobox() {return sCombo;}
   public void setCombobox(String value) {sCombo= value;}
   public Dimension getComboboxPreferredSize() {return getXPreferredSize();}

 
   public void setLandscape(boolean isLandscape) {this.isLandscape = isLandscape;}
   public boolean getLandscape() {return isLandscape;}

   
   public Test20PreferredSize() {
      JComponent panel = xyAlign(.5, .5, new JPanel());
      JComponent button = xyAlign(.5, .5, new JButton("Button"));
      JComponent spinner = xyAlign(.5, .5, new JSpinner());
      JComponent combobox = xyAlign(.5, .5, new JComboBox(new String[] {"A","B"}));
      JCheckBox landscape = new JCheckBox("Landscape (unchecking displays portrait)");
      
      JLabel msg = new JLabel(
"<html>Checking landscape shows all components in landscape orientation, otherwise portrait.");
      Object[][] breadboard = {
         {null,        xSpace(100), xSpace(100), null},
         {null,        landscape,   __,          __},
         {ySpace(200), panel,       button,      null},
         {ySpace(200), spinner,     combobox,      null},
         {null,        msg,         __,          __}
      };
      setBreadboard(breadboard);
      jbConnect(panel, "panel");
      jbConnect(button, "button");
      jbConnect(spinner, "spinner");
      jbConnect(combobox, "combobox");
      jbConnect(landscape, "landscape");
   }
   public static void main(String[] args) {
	   showMessageBreadboard(null, new Test20PreferredSize(),"Test20PreferredSize()");
   }

 }
