

import javax.swing.*;

import net.sourceforge.jcomponentbreadboard.JComponentBreadboard;

/** 
 ** Tests the ability to connect forms to each other, in linear or circular
 ** references.
 **/ 
@SuppressWarnings("serial")
public class Test99NestedConnections extends JComponentBreadboard {
   
   public static class SubForm extends JComponentBreadboard {
	 private boolean[] booleanData;
     SubForm(boolean[] b) {
        booleanData = b;
        JComponent bool = new JCheckBox("Boolean data");
        JLabel msg = new JLabel("<html><h1>This is a subform");
        Object[][] breadboard = {
           {bool},
           {msg}
        };
        setBreadboard(breadboard);
        jbConnect(bool, "booleanData");
     }
     public void setBooleanData(boolean b) {
        booleanData[0] = b;
     }
     public boolean getBooleanData() {
      return booleanData[0];
     }
   }

   private boolean[] booleanData = new boolean[1];
   
   public Test99NestedConnections() {
      JCheckBox bool = new JCheckBox("Boolean data");
      JComponentBreadboard bbA = new SubForm(booleanData);
      JComponentBreadboard bbB = new SubForm(booleanData);
      this.jbConnect(bbA, "bbA");
      bbA.jbConnect(bbB, "bbB");
      bbB.jbConnect(bbA, "bbA");
      JDialog d1 = createBreadboardDialog(null, bbA, "SubForm A", false);
      JDialog d2 = createBreadboardDialog(null, bbB, "SubForm B", false);



        JLabel msg = new JLabel(
"<html>Verify: Clicking Boolean data in this form changes it in both subforms<br>" +
"Clicking in either subform changes it in other subform, but NOT in this form.");
        Object[][] breadboard = {
           {bool},
           {msg}
        };
        setBreadboard(breadboard);
        jbConnect(bool, "booleanData");

      d1.setVisible(true);
      
      d2.setVisible(true);
       
      d1.setLocation(0,0);  
      d2.setLocation(0, d1.getHeight());
   }
   
     public void setBooleanData(boolean b) {
        booleanData[0] = b;
     }
     public boolean getBooleanData() {
      return booleanData[0];
     }
   public static void main(String[] args) {
      JDialog d = createBreadboardDialog(null, new Test99NestedConnections(), "Test99NestedConnections()", false);
      d.setVisible( true);
   }
}
